Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool.pod
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool.pod	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool.pod	(revision 34921)
@@ -2009,29 +2509,83 @@
 
 Certain meta information formats allow coded character sets other than plain
-ASCII.  When reading, 8-bit encodings are passed straight through ExifTool
-without re-coding unless specified otherwise below, and multi-byte encodings
-are converted according to the L</Charset> option ('UTF8' by default).  When
-writing, the inverse conversions are performed.  See the L</Charset> option
-for a list of valid character sets.
+ASCII.  When reading, most known encodings are converted to the external
+character set according to the L</Charset> option, or to UTF-8 by default.
+When writing, the inverse conversions are performed.  Alternatively, special
+characters may be converted to/from HTML character entities with the
+L</Escape> HTML option.
+
+A distinction is made between the external character set visible via the
+ExifTool API, and the internal character used to store text in the metadata
+of a file.  These character sets may be specified separately as follows:
+
+=over 4
+
+=item External Character Sets:
+
+The encoding for tag values passed to/from ExifTool API functions is set via
+the L</Charset> option, which is 'UTF8' by default.
+
+The encoding of file names is specified via the L</CharsetFileName> option.
+By default, L</CharsetFileName> is not defined, and file names passed to
+ExifTool are used directly in calls to the system i/o routines (which expect
+UTF-8 strings on Mac/Linux, but default to the system code page on Windows).
+In this mode on Windows a warning is issued if a file name contains special
+characters, but this warning may be avoided by setting L</CharsetFileName>
+to an empty string.  Setting L</CharsetFileName> to any other value causes
+file names to be converted from the specified encoding to one appropriate
+for the system.  In Windows this also has the effect of activating Unicode
+filename support via the special Windows wide-character i/o routines if
+Win32API::File is available.
+
+=item Internal Character Sets:
+
+The encodings used to store strings in the various metadata formats.  These
+encodings may be changed for certain types of metadata via the
+L</CharsetEXIF>, L</CharsetID3>, L</CharsetIPTC>, L</CharsetPhotoshop>,
+L</CharsetQuickTime> and L</CharsetRIFF> options.
+
+=back
+
+Values are returned as byte strings of encoded characters.  Perl wide
+characters are not used.  By default, most returned strings are encoded in
+UTF-8.  For these, Encode::decode_utf8() may be used to convert to a
+sequence of logical Perl characters.  Note that some settings of the
+PERL_UNICODE environment variable may be incompatible with ExifTool's
+character handling.
 
 More specific details are given below about how character coding is handled
-for EXIF, IPTC, XMP, PNG, ID3, PDF and MIE information:
+for EXIF, IPTC, XMP, PNG, ID3, PDF, Photoshop, QuickTime, AIFF, MIE and
+Vorbis information:
 
 =head2 EXIF
 
-Most textual information in EXIF is stored in ASCII format, and ExifTool
-does not convert these tags.  However it is not uncommon for applications to
-write UTF-8 or other encodings where ASCII is expected, and ExifTool will
-quite happily read/write any encoding without conversion.  For a few EXIF
-tags (UserComment, GPSProcessingMethod and GPSAreaInformation) the stored
-text may be encoded either in ASCII, Unicode (UCS-2) or JIS.  When reading
-these tags, Unicode and JIS are converted to the character set specified by
-the L</Charset> option.  Other encodings are not converted.  When writing,
+Most textual information in EXIF is stored in ASCII format (called "string"
+in the L<ExifTool tag name documentation|Image::ExifTool::TagNames>). By
+default ExifTool does not convert these strings.  However, it is not
+uncommon for applications to write UTF-8 or other encodings where ASCII is
+expected.  To deal with these, ExifTool allows the internal EXIF string
+encoding to be specified with L</CharsetEXIF>, which causes EXIF string
+values to be converted from the specified character set when reading, and
+stored with this character set when writing.  (The MWG recommends using
+UTF-8 encoding for EXIF strings, and in keeping with this the
+L<MWG|Image::ExifTool::MWG> module sets the default internal EXIF string
+encoding to UTF-8, but note that this will have no effect unless the
+external encoding is also set to something other than the default of UTF-8.)
+
+A few EXIF tags (UserComment, GPSProcessingMethod and GPSAreaInformation)
+support a designated internal text encoding, with values stored as ASCII,
+Unicode (UCS-2) or JIS.  When reading these tags, ExifTool converts Unicode
+and JIS to the external character set specified by the L</Charset>
+option, or to UTF-8 by default.  ASCII text is not converted. When writing,
 text is stored as ASCII unless the string contains special characters, in
-which case it is converted from the specified character set and stored as
-Unicode.  ExifTool writes Unicode in native EXIF byte ordering by default,
-but this may be changed by setting the ExifUnicodeByteOrder tag.  The EXIF
-"XP" tags (XPTitle, XPComment, etc) are always stored as little-endian
-Unicode, and are read and written using the specified character set.
+which case it is converted from the external character set (UTF-8 by
+default), and stored as Unicode. ExifTool writes Unicode in native EXIF byte
+ordering by default, but the byte order may be specified by setting the
+ExifUnicodeByteOrder tag (see the
+L<Extra Tags documentation|Image::ExifTool::TagNames/Extra Tags>).
+
+The EXIF "XP" tags (XPTitle, XPComment, etc) are always stored as
+little-endian Unicode (UCS-2), and are read and written using the specified
+character set.
 
 =head2 IPTC
@@ -2047,10 +2601,39 @@
 character sets are the same.  Note that ISO 2022 character set shifting is
 not supported.  Instead, a warning is issued and the string is not converted
-if an ISO 2022 shift code is found.  See L<http://www.iptc.org/IIM/> for the
-official IPTC specification.
+if an ISO 2022 shift code is encountered.  See L<http://www.iptc.org/IIM/>
+for the official IPTC specification.
+
+ExifTool may be used to convert IPTC values to a different internal
+encoding.  To do this, all IPTC tags must be rewritten along with the
+desired value of CodedCharacterSet.  For example, the following command
+changes the internal IPTC encoding to UTF-8 (from Windows Latin1 unless
+CodedCharacterSet was already 'UTF8'):
+
+  exiftool -tagsfromfile @ -iptc:all -codedcharacterset=utf8 a.jpg
+
+or from Windows Latin2 (cp1250) to UTF-8:
+
+  exiftool -tagsfromfile @ -iptc:all -codedcharacterset=utf8 \
+  -charset iptc=latin2 a.jpg
+
+and this command changes it back from UTF-8 to Windows Latin1 (cp1252):
+
+  exiftool -tagsfromfile @ -iptc:all -codedcharacterset= a.jpg
+
+or to Windows Latin2:
+
+  exiftool -tagsfromfile @ -iptc:all -codedcharacterset= \
+  -charset iptc=latin2 a.jpg
+
+Unless CodedCharacterSet is 'UTF8', applications have no reliable way to
+determine the IPTC character encoding.  For this reason, it is recommended
+that CodedCharacterSet be set to 'UTF8' when creating new IPTC.
+
+(Note: Here, "IPTC" Refers to the older IPTC IIM format.  The more recent
+IPTC Core and Extension specifications actually use the XMP format.)
 
 =head2 XMP
 
-Exiftool reads XMP encoded as UTF-8, UTF-16 or UTF-32, and converts them all
+ExifTool reads XMP encoded as UTF-8, UTF-16 or UTF-32, and converts them all
 to UTF-8 internally.  Also, all XML character entity references and numeric
 character references are converted.  When writing, ExifTool always encodes
@@ -2058,5 +2641,5 @@
 references: E<amp> E<lt> E<gt> E<39> E<quot>.  By default no further
 conversion is performed, however if the L</Charset> option is other than
-'UTF8' then text is converted to/from a specified character set when
+'UTF8' then text is converted to/from the specified character set when
 reading/writing.
 
@@ -2072,4 +2655,9 @@
 text is converted from the specified character set and stored as UTF-8.
 
+=head2 JPEG Comment
+
+The encoding for the JPEG Comment (COM segment) is not specified, so
+ExifTool reads/writes this text without conversion.
+
 =head2 ID3
 
@@ -2077,9 +2665,9 @@
 subset of Windows Latin1), although some applications may incorrectly use
 other character sets.  By default ExifTool converts ID3v1 text from Latin to
-the character set specified by the </Charset> option.  However, the internal
-ID3v1 charset may be specified with the L</CharsetID3> option.  The encoding
-for ID3v2 information is stored in the file, so ExifTool converts ID3v2 text
-from this encoding to the character set specified by the L</Charset> option.
-ExifTool does not currently write ID3 information.
+the character set specified by the L</Charset> option.  However, the
+internal ID3v1 charset may be specified with the L</CharsetID3> option.  The
+encoding for ID3v2 information is stored in the file, so ExifTool converts
+ID3v2 text from this encoding to the character set specified by the
+L</Charset> option. ExifTool does not currently write ID3 information.
 
 =head2 PDF
@@ -2090,4 +2678,30 @@
 encodes input text from the specified character set as Unicode only if the
 string contains special characters, otherwise PDFDocEncoding is used.
+
+=head2 Photoshop
+
+Some Photoshop resource names are stored as Pascal strings with unknown
+encoding.  By default, ExifTool assumes MacRoman encoding and converts this
+to UTF-8, but the internal and external character sets may be specified with
+the L</CharsetPhotoshop> and L</Charset> options respectively.
+
+=head2 QuickTime
+
+QuickTime text strings may be stored in a variety of poorly document
+formats. ExifTool does its best to decode these according to the L</Charset>
+option setting.  For some QuickTime strings, ExifTool assumes a default
+encoding of MacRoman, but this may be changed with the L</CharsetQuickTime>
+option.
+
+=head2 AIFF
+
+AIFF strings are assumed to be stored in MacRoman, and are converted
+according to the L</Charset> option when reading.
+
+=head2 RIFF
+
+The internal encoding of RIFF strings (eg. in AVI and WAV files) is assumed
+to be Latin unless otherwise specified by the RIFF CSET chunk or the
+L</CharsetRIFF> option.
 
 =head2 MIE
@@ -2100,7 +2714,12 @@
 are stored as ISO 8859-1.
 
+=head2 Vorbis
+
+Vorbis comments are stored as UTF-8, and are converted to the character set
+specified by the L</Charset> option.
+
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey
+Copyright 2003-2021, Phil Harvey
 
 This library is free software; you can redistribute it and/or modify it
@@ -2120,5 +2739,5 @@
 L<Image::ExifTool::TagNames(3pm)|Image::ExifTool::TagNames>,
 L<Image::ExifTool::Shortcuts(3pm)|Image::ExifTool::Shortcuts>,
-L<Image::ExifTool::Shift.pl|Image::ExifTool::Shift.pl>,
+L<Image::ExifTool::Shift(3pm)|Image::ExifTool::Shift.pl>,
 L<Image::Info(3pm)|Image::Info>,
 L<Image::MetaData::JPEG(3pm)|Image::MetaData::JPEG>
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AES.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AES.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AES.pm	(revision 34921)
@@ -103,5 +103,5 @@
     # temporary variables (all unsigned characters)
     my ($i,@temp);
-    
+
     # The first round key is the key itself.
     for ($i=0; $i<$nk; ++$i) {
@@ -336,5 +336,5 @@
 #         3) flag to disable padding
 # Returns: error string, or undef on success
-# Notes: encrypts/decrypts data in place
+# Notes: encrypts/decrypts data in place (encrypted data returned with leading IV)
 sub Crypt($$;$$)
 {
@@ -478,5 +478,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AFCP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AFCP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AFCP.pm	(revision 34921)
@@ -6,5 +6,5 @@
 # Revisions:    12/26/2005 - P. Harvey Created
 #
-# References:   1) http://www.tocarte.com/media/axs_afcp_spec.pdf
+# References:   1) http://web.archive.org/web/20080828211305/http://www.tocarte.com/media/axs_afcp_spec.pdf
 #------------------------------------------------------------------------------
 
@@ -15,5 +15,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.04';
+$VERSION = '1.08';
 
 sub ProcessAFCP($$);
@@ -29,4 +29,8 @@
 ExifTool will read and write (but not create) AFCP IPTC information in JPEG
 and TIFF images.
+
+See
+L<http://web.archive.org/web/20080828211305/http://www.tocarte.com/media/axs_afcp_spec.pdf>
+for the AFCP specification.
     },
     IPTC => { SubDirectory => { TagTable => 'Image::ExifTool::IPTC::Main' } },
@@ -34,4 +38,5 @@
     Nail => {
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         # (the specification allows for a variable amount of padding before
         #  the image after a 10-byte header, so look for the JPEG SOI marker,
@@ -46,4 +51,5 @@
     PrVw => {
         Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
         RawConv => q{
             pos($val) = 10;
@@ -66,5 +72,5 @@
 sub ProcessAFCP($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $curPos = $raf->Tell();
@@ -116,12 +122,12 @@
 
         $rtnVal = 1;
-        my $verbose = $exifTool->Options('Verbose');
-        my $out = $exifTool->Options('TextOut');
+        my $verbose = $et->Options('Verbose');
+        my $out = $et->Options('TextOut');
         my $outfile = $$dirInfo{OutFile};
         if ($outfile) {
             # allow all AFCP information to be deleted
-            if ($exifTool->{DEL_GROUP}->{AFCP}) {
+            if ($$et{DEL_GROUP}{AFCP}) {
                 $verbose and print $out "  Deleting AFCP\n";
-                ++$exifTool->{CHANGED};
+                ++$$et{CHANGED};
                 last;
             }
@@ -132,5 +138,5 @@
             $vers = substr($buff, 4, 2); # get version number
         } else {
-            $exifTool->DumpTrailer($dirInfo) if $verbose or $exifTool->{HTML_DUMP};
+            $et->DumpTrailer($dirInfo) if $verbose or $$et{HTML_DUMP};
         }
         # read AFCP directory data
@@ -138,5 +144,5 @@
         my $dir;
         unless ($raf->Read($dir, 12 * $numEntries) == 12 * $numEntries) {
-            $exifTool->Error('Error reading AFCP directory', 1);
+            $et->Error('Error reading AFCP directory', 1);
             last;
         }
@@ -144,12 +150,7 @@
             my $dat = $buff . $dir;
             print $out "  AFCP Directory:\n";
-            Image::ExifTool::HexDump(\$dat, undef,
-                Addr   => $$dirInfo{DataPos},
-                Width  => 12,
-                Prefix => $exifTool->{INDENT},
-                Out => $out,
-            );
-        }
-        $fix and $exifTool->Warn("Adjusted AFCP offsets by $fix", 1);
+            $et->VerboseDump(\$dat, Addr => $$dirInfo{DataPos}, Width  => 12);
+        }
+        $fix and $et->Warn("Adjusted AFCP offsets by $fix", 1);
 #
 # process AFCP directory
@@ -168,5 +169,5 @@
                 if ($outfile) {
                     # rewrite this information
-                    my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+                    my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
                     if ($tagInfo and $$tagInfo{SubDirectory}) {
                         my %subdirInfo = (
@@ -178,5 +179,5 @@
                         );
                         my $subTable = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
-                        my $newDir = $exifTool->WriteDirectory(\%subdirInfo, $subTable);
+                        my $newDir = $et->WriteDirectory(\%subdirInfo, $subTable);
                         if (defined $newDir) {
                             $size = length $newDir;
@@ -189,5 +190,5 @@
                 } else {
                     # extract information
-                    $exifTool->HandleTag($tagTablePtr, $tag, $buff,
+                    $et->HandleTag($tagTablePtr, $tag, $buff,
                         DataPt => \$buff,
                         Size => $size,
@@ -197,5 +198,5 @@
                 }
             } else {
-                $exifTool->Warn("Bad AFCP directory");
+                $et->Warn("Bad AFCP directory");
                 $rtnVal = -1 if $outfile;
                 last;
@@ -259,5 +260,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AIFF.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AIFF.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/AIFF.pm	(revision 34921)
@@ -19,5 +19,5 @@
 use Image::ExifTool::ID3;
 
-$VERSION = '1.03';
+$VERSION = '1.11';
 
 # information for time/date-based tags (time zero is Jan 1, 1904)
@@ -31,5 +31,9 @@
 %Image::ExifTool::AIFF::Main = (
     GROUPS => { 2 => 'Audio' },
-    NOTES => 'Only the tags decoded by ExifTool are listed in this table.',
+    NOTES => q{
+        Tags extracted from Audio Interchange File Format (AIFF) files.  See
+        L<http://www-mmsp.ece.mcgill.ca/Documents/AudioFormats/AIFF/AIFF.html> for
+        the AIFF specification.
+    },
 #    FORM => 'Format',
     FVER => {
@@ -45,8 +49,22 @@
         SubDirectory => { TagTable => 'Image::ExifTool::AIFF::Comment' },
     },
-    NAME => 'Name',
-    AUTH => { Name => 'Author', Groups => { 2 => 'Author' } },
-   '(c) ' => { Name => 'Copyright', Groups => { 2 => 'Author' } },
-    ANNO => 'Annotation',
+    NAME => {
+        Name => 'Name',
+        ValueConv => '$self->Decode($val, "MacRoman")',
+    },
+    AUTH => {
+        Name => 'Author',
+        Groups => { 2 => 'Author' },
+        ValueConv => '$self->Decode($val, "MacRoman")',
+    },
+   '(c) ' => {
+        Name => 'Copyright',
+        Groups => { 2 => 'Author' },
+        ValueConv => '$self->Decode($val, "MacRoman")',
+    },
+    ANNO => {
+        Name => 'Annotation',
+        ValueConv => '$self->Decode($val, "MacRoman")',
+    },
    'ID3 ' => {
         Name => 'ID3',
@@ -56,4 +74,5 @@
         },
     },
+    APPL => 'ApplicationData', # (first 4 bytes are the application signature)
 #    SSND => 'SoundData',
 #    MARK => 'Marker',
@@ -61,5 +80,4 @@
 #    MIDI => 'MidiData',
 #    AESD => 'AudioRecording',
-#    APPL => 'ApplicationSpecific',
 );
 
@@ -82,5 +100,18 @@
             MAC6 => 'MAC 6-to-1',
             sowt => 'Little-endian, no compression',
+            alaw => 'a-law',
+            ALAW => 'A-law',
+            ulaw => 'mu-law',
+            ULAW => 'Mu-law',
+           'GSM '=> 'GSM',
+            G722 => 'G722',
+            G726 => 'G726',
+            G728 => 'G728',
         },
+    },
+    11 => { #PH
+        Name => 'CompressorName',
+        Format => 'pstring',
+        ValueConv => '$self->Decode($val, "MacRoman")',
     },
 );
@@ -97,6 +128,24 @@
     0 => { Name => 'CommentTime', %timeInfo },
     1 => 'MarkerID',
-    2 => 'Comment',
-);
+    2 => {
+        Name => 'Comment',
+        ValueConv => '$self->Decode($val, "MacRoman")',
+    },
+);
+
+%Image::ExifTool::AIFF::Composite = (
+    Duration => {
+        Require => {
+            0 => 'AIFF:SampleRate',
+            1 => 'AIFF:NumSampleFrames',
+        },
+        RawConv => '($val[0] and $val[1]) ? $val[1] / $val[0] : undef',
+        PrintConv => 'ConvertDuration($val)',
+    },
+);
+
+# add our composite tags
+Image::ExifTool::AddCompositeTags('Image::ExifTool::AIFF');
+
 
 #------------------------------------------------------------------------------
@@ -106,22 +155,22 @@
 sub ProcessComment($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirLen = $$dirInfo{DirLen};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     return 0 unless $dirLen > 2;
     my $numComments = unpack('n',$$dataPt);
     my $pos = 2;
     my $i;
-    $verbose and $exifTool->VerboseDir('Comment', $numComments);
+    $verbose and $et->VerboseDir('Comment', $numComments);
     for ($i=0; $i<$numComments; ++$i) {
         last if $pos + 8 > $dirLen;
         my ($time, $markerID, $size) = unpack("x${pos}Nnn", $$dataPt);
-        $exifTool->HandleTag($tagTablePtr, 0, $time);
-        $exifTool->HandleTag($tagTablePtr, 1, $markerID) if $markerID;
+        $et->HandleTag($tagTablePtr, 0, $time);
+        $et->HandleTag($tagTablePtr, 1, $markerID) if $markerID;
         $pos += 8;
         last if $pos + $size > $dirLen;
         my $val = substr($$dataPt, $pos, $size);
-        $exifTool->HandleTag($tagTablePtr, 2, $val);
+        $et->HandleTag($tagTablePtr, 2, $val);
         ++$size if $size & 0x01;    # account for padding byte if necessary
         $pos += $size;
@@ -135,10 +184,11 @@
 sub ProcessAIFF($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
-    my ($buff, $err, $tagTablePtr, $page, $type);
+    my ($buff, $err, $tagTablePtr, $page, $type, $n);
 
     # verify this is a valid AIFF file
     return 0 unless $raf->Read($buff, 12) == 12;
+    my $fast3 = $$et{OPTIONS}{FastScan} && $$et{OPTIONS}{FastScan} == 3;
     my $pos = 12;
     # check for DjVu image
@@ -150,32 +200,45 @@
         $pos += 4;
         $buff = substr($buff, 4) . $buf2;
+        $et->SetFileType('DJVU');
+        return 1 if $fast3;
         $tagTablePtr = GetTagTable('Image::ExifTool::DjVu::Main');
-        $exifTool->SetFileType('DJVU');
-        # modifiy FileType to indicate a multi-page document
-        $exifTool->{VALUE}->{FileType} .= " (multi-page)" if $buf2 eq 'DJVM';
+        # modify FileType to indicate a multi-page document
+        $$et{VALUE}{FileType} .= " (multi-page)" if $buf2 eq 'DJVM';
         $type = 'DjVu';
     } else {
         return 0 unless $buff =~ /^FORM....(AIF(F|C))/s;
-        $exifTool->SetFileType($1);
+        $et->SetFileType($1);
+        return 1 if $fast3;
         $tagTablePtr = GetTagTable('Image::ExifTool::AIFF::Main');
         $type = 'AIFF';
     }
     SetByteOrder('MM');
+    my $verbose = $et->Options('Verbose');
 #
 # Read through the IFF chunks
 #
-    for (;;) {
+    for ($n=0;;++$n) {
         $raf->Read($buff, 8) == 8 or last;
         $pos += 8;
         my ($tag, $len) = unpack('a4N', $buff);
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
-        $exifTool->VPrint(0, "AIFF '$tag' chunk ($len bytes of data):\n");
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+        $et->VPrint(0, "AIFF '${tag}' chunk ($len bytes of data): ", $raf->Tell(),"\n");
         # AIFF chunks are padded to an even number of bytes
         my $len2 = $len + ($len & 0x01);
+        if ($len2 > 100000000) {
+            if ($len2 >= 0x80000000 and not $et->Options('LargeFileSupport')) {
+                $et->Warn('End of processing at large chunk (LargeFileSupport not enabled)');
+                last;
+            }
+            if ($tagInfo) {
+                $et->Warn("Skipping large $$tagInfo{Name} chunk (> 100 MB)");
+                undef $tagInfo;
+            }
+        }
         if ($tagInfo) {
             if ($$tagInfo{TypeOnly}) {
                 $len = $len2 = 4;
                 $page = ($page || 0) + 1;
-                $exifTool->VPrint(0, $exifTool->{INDENT} . "Page $page:\n");
+                $et->VPrint(0, $$et{INDENT} . "Page $page:\n");
             }
             $raf->Read($buff, $len2) >= $len or $err=1, last;
@@ -183,5 +246,5 @@
                 $buff =~ s/\0+$//;  # remove trailing nulls
             }
-            $exifTool->HandleTag($tagTablePtr, $tag, $buff,
+            $et->HandleTag($tagTablePtr, $tag, $buff,
                 DataPt => \$buff,
                 DataPos => $pos,
@@ -189,10 +252,18 @@
                 Size => $len,
             );
+        } elsif (not $len) {
+            next if ++$n < 100;
+            $et->Warn('Aborting scan.  Too many empty chunks');
+            last;
+        } elsif ($verbose > 2 and $len2 < 1024000) {
+            $raf->Read($buff, $len2) == $len2 or $err = 1, last;
+            $et->VerboseDump(\$buff);
         } else {
             $raf->Seek($len2, 1) or $err=1, last;
         }
         $pos += $len2;
+        $n = 0;
     }
-    $err and $exifTool->Warn("Error reading $type file (corrupted?)");
+    $err and $et->Warn("Error reading $type file (corrupted?)");
     return 1;
 }
@@ -217,5 +288,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/APE.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/APE.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/APE.pm	(revision 34921)
@@ -16,5 +16,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.01';
+$VERSION = '1.06';
 
 # APE metadata blocks
@@ -24,5 +24,6 @@
         Tags found in Monkey's Audio (APE) information.  Only a few common tags are
         listed below, but ExifTool will extract any tag found.  ExifTool supports
-        APEv1 and APEv2 tags, as well as ID3 information in APE files.
+        APEv1 and APEv2 tags, as well as ID3 information in APE files, and will also
+        read APE metadata from MP3 and MPC files.
     },
     Album   => { },
@@ -32,4 +33,9 @@
     Track   => { },
     Year    => { },
+    DURATION => {
+        Name => 'Duration',
+        ValueConv => '$val += 4294967296 if $val < 0 and $val >= -2147483648; $val * 1e-7',
+        PrintConv => 'ConvertDuration($val)',
+    },
     'Tool Version' => { Name => 'ToolVersion' },
     'Tool Name'    => { Name => 'ToolName' },
@@ -72,4 +78,22 @@
 );
 
+# APE Composite tags
+%Image::ExifTool::APE::Composite = (
+    GROUPS => { 2 => 'Audio' },
+    Duration => {
+        Require => {
+            0 => 'APE:SampleRate',
+            1 => 'APE:TotalFrames',
+            2 => 'APE:BlocksPerFrame',
+            3 => 'APE:FinalFrameBlocks',
+        },
+        RawConv => '($val[0] && $val[1]) ? (($val[1] - 1) * $val[2] + $val[3]) / $val[0]: undef',
+        PrintConv => 'ConvertDuration($val)',
+    },
+);
+
+# add our composite tags
+Image::ExifTool::AddCompositeTags('Image::ExifTool::APE');
+
 #------------------------------------------------------------------------------
 # Make tag info hash for specified tag
@@ -83,5 +107,7 @@
     $name =~ s/[^\w-]+(.?)/\U$1/sg;
     $name =~ s/([a-z0-9])_([a-z])/$1\U$2/g;
-    Image::ExifTool::AddTagToTable($tagTablePtr, $tag, { Name => $name });
+    my %tagInfo = ( Name => $name );
+    $tagInfo{Groups} = { 2 => 'Preview' } if $tag =~ /^Cover Art/ and $tag !~ /Desc$/;
+    AddTagToTable($tagTablePtr, $tag, \%tagInfo);
 }
 
@@ -93,21 +119,23 @@
 sub ProcessAPE($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
 
     # must first check for leading/trailing ID3 information
-    unless ($exifTool->{DoneID3}) {
+    unless ($$et{DoneID3}) {
         require Image::ExifTool::ID3;
-        Image::ExifTool::ID3::ProcessID3($exifTool, $dirInfo) and return 1;
+        Image::ExifTool::ID3::ProcessID3($et, $dirInfo) and return 1;
     }
     my $raf = $$dirInfo{RAF};
-    my $verbose = $exifTool->Options('Verbose');
-    my ($buff, $i, $header, $tagTablePtr, $dataPos);
+    my $verbose = $et->Options('Verbose');
+    my ($buff, $i, $header, $tagTablePtr, $dataPos, $oldIndent);
+
+    $$et{DoneAPE} = 1;
 
     # check APE signature and process audio information
     # unless this is some other type of file
-    unless ($exifTool->{VALUE}->{FileType}) {
+    unless ($$et{VALUE}{FileType}) {
         $raf->Read($buff, 32) == 32 or return 0;
         $buff =~ /^(MAC |APETAGEX)/ or return 0;
-        $exifTool->SetFileType();
+        $et->SetFileType();
         SetByteOrder('II');
 
@@ -131,5 +159,5 @@
                 }
             }
-            $exifTool->ProcessDirectory( { DataPt => \$buff }, $table) if $table;
+            $et->ProcessDirectory( { DataPt => \$buff }, $table) if $table;
         }
     }
@@ -139,5 +167,5 @@
         my $footPos = -32;
         # (...but before the ID3v1 trailer if it exists)
-        $footPos -= 128 if $exifTool->{DoneID3} == 2;
+        $footPos -= $$et{DoneID3} if $$et{DoneID3} > 1;
         $raf->Seek($footPos, 2)     or return 1;
         $raf->Read($buff, 32) == 32 or return 1;
@@ -156,6 +184,8 @@
     {
         if ($verbose) {
-            $exifTool->VerboseDir("APEv$version", $count, $size);
-            $exifTool->VerboseDump(\$buff, DataPos => $raf->Tell() - $size);
+            $oldIndent = $$et{INDENT};
+            $$et{INDENT} .= '| ';
+            $et->VerboseDir("APEv$version", $count, $size);
+            $et->VerboseDump(\$buff, DataPos => $raf->Tell() - $size);
         }
         $tagTablePtr = GetTagTable('Image::ExifTool::APE::Main');
@@ -176,4 +206,6 @@
         last unless $buff =~ /\G(.*?)\0/sg;
         my $tag = $1;
+        # avoid conflicts with our special table entries
+        $tag .= '.' if $Image::ExifTool::specialTags{$tag};
         $pos = pos($buff);
         last if $pos + $len > $size;
@@ -191,9 +223,9 @@
                     my $v = $1;
                     MakeTag($t, $tagTablePtr) unless $$tagTablePtr{$t};
-                    $exifTool->HandleTag($tagTablePtr, $t, $v);
+                    $et->HandleTag($tagTablePtr, $t, $v);
                 }
             }
         }
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        $et->HandleTag($tagTablePtr, $tag, $val,
             Index => $i,
             DataPt => \$buff,
@@ -204,5 +236,6 @@
         $pos += $len;
     }
-    $i == $count or $exifTool->Warn('Bad APE trailer');
+    $i == $count or $et->Warn('Bad APE trailer');
+    $$et{INDENT} = $oldIndent if defined $oldIndent;
     return 1;
 }
@@ -231,5 +264,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
